/*
 *
 *  This file ist part of the software MonaLisa.
 *  MonaLisa is free software, dependend on non-free software. For more information read LICENCE and README.
 *
 *  (c) Molekulare Bioinformatik, Goethe University Frankfurt, Frankfurt am Main, Germany
 *
 */

package monalisa.addons.netviewer;

import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.graph.util.Context;
import java.awt.Shape;
import java.awt.geom.GeneralPath;
import org.apache.commons.collections15.Transformer;

/**
 * Shape transformer for arrow heads (size changeable)
 * @author Jens Einloft
 */
public class EdgeArrowTransformer implements Transformer<Context<Graph<NetViewerNode, NetViewerEdge>, NetViewerEdge>, Shape> {

    private Float factor;

    public EdgeArrowTransformer(Float factor) {
        this.factor = factor;
    }

    public Shape transform(Context<Graph<NetViewerNode, NetViewerEdge>, NetViewerEdge> i) {
        Double dFactor = new Double(this.factor);
        Double height = 10.0*dFactor;
        Double base = 8.0*dFactor;
        Double notch_height = 3.0*dFactor;

        GeneralPath arrow = new GeneralPath();
        arrow.moveTo(0,0);
        arrow.lineTo(-height, base/2.0f);
        arrow.lineTo(-(height - notch_height), 0);
        arrow.lineTo(-height, -base/2.0f);
        arrow.lineTo(0,0);
        return arrow;
    }

}
