/*
 *
 *  This file ist part of the software MonaLisa.
 *  MonaLisa is free software, dependend on non-free software. For more information read LICENCE and README.
 *
 *  (c) Molekulare Bioinformatik, Goethe University Frankfurt, Frankfurt am Main, Germany
 *
 */

package monalisa.addons.util;

import java.io.File;
import javax.swing.filechooser.FileFilter;
import monalisa.util.FileUtils;

/**
 * File filter
 * @author Jens Einloft
 */
public class MyFileFilter extends FileFilter {
        private String extension;
        private String description;

        public MyFileFilter(String extension, String description) {
            this.extension = extension;
            this.description = description;
        }

        public File checkFileNameForExtension(File file) {
            if(!extension.equalsIgnoreCase(FileUtils.getExtension(file)))
                file = new File(file.getAbsolutePath()+"."+extension);
            return file;
        }

        public String getExtension() {
            return extension;
        }

        @Override
        public String getDescription() {
            return "*."+extension+" ("+description+")";
        }

        @Override
        public boolean accept(File f) {
            if(f.isDirectory() || extension.equalsIgnoreCase(FileUtils.getExtension(f)))
                return true;
            else
                return false;
        }
}
