/*
 *
 *  This file ist part of the software MonaLisa.
 *  MonaLisa is free software, dependend on non-free software. For more information read LICENCE and README.
 *
 *  (c) Molekulare Bioinformatik, Goethe University Frankfurt, Frankfurt am Main, Germany
 *
 */

package monalisa.results;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import monalisa.Project;

public final class Clustering implements Result {
    private static final long serialVersionUID = -995041259896104069L;
    private final String fileContent;
    private final String filenameExtension;

    public Clustering(String fileContent, String filenameExtension) {
        this.fileContent = fileContent;
        this.filenameExtension = filenameExtension;
    }
    
    @Override
    public void export(File path, Configuration config, Project project)
            throws IOException {
        FileWriter writer = null;
        try {
            writer = new FileWriter(path);
            writer.write(fileContent);
        }
        finally {
            if (writer != null)
                writer.close();
        }
    }

    @Override
    public String filenameExtension() {
        return filenameExtension;
    }

}
