/*
 *
 *  This file ist part of the software MonaLisa.
 *  MonaLisa is free software, dependend on non-free software. For more information read LICENCE and README.
 *
 *  (c) Molekulare Bioinformatik, Goethe University Frankfurt, Frankfurt am Main, Germany
 *
 */

package monalisa.results;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;

import monalisa.Project;

public final class MauritiusMap implements Result {
    private static final long serialVersionUID = -8260517639800715422L;
    private final String sourceCode;
    
    public MauritiusMap(String sourceCode) {
        this.sourceCode = sourceCode;
    }

    @Override
    public void export(File path, Configuration config, Project project) throws IOException {
        PrintWriter out = null;
        try {
            out = new PrintWriter(path);
            out.write(sourceCode);
            out.close();
        }
        finally {
            if (out != null)
                out.close();
        }
    }

    @Override
    public String filenameExtension() {
        return "ps";
    }
}
