/*
 *
 *  This file ist part of the software MonaLisa.
 *  MonaLisa is free software, dependend on non-free software. For more information read LICENCE and README.
 *
 *  (c) Molekulare Bioinformatik, Goethe University Frankfurt, Frankfurt am Main, Germany
 *
 */

package monalisa.results;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;

import monalisa.Project;

public final class Topology implements Result {
    private static final long serialVersionUID = 2407567962533699791L;

    public static final String PLAIN = "PLAIN";
    public static final String R = "R";

    private final String results;
    private final String type;
    
    public Topology(String results, String type) {
        this.results = results;
        this.type = type;
    }
    
    @Override
    public void export(File path, Configuration config, Project project)
            throws IOException {
        PrintWriter printer = null;
        try {
            printer = new PrintWriter(path);
            printer.print(results);
        }
        finally {
            if (printer != null)
                printer.close();
        }
    }
    
    @Override
    public String filenameExtension() {
        if(this.type.equals(Topology.R))
            return "R";
        else
            return "txt";
    }

}
