/*
 *
 *  This file ist part of the software MonaLisa.
 *  MonaLisa is free software, dependend on non-free software. For more information read LICENCE and README.
 *
 *  (c) Molekulare Bioinformatik, Goethe University Frankfurt, Frankfurt am Main, Germany
 *
 */

package monalisa.results;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Vector;
import monalisa.Project;
import monalisa.tools.cluster.Cluster.Edge;
import monalisa.tools.cluster.Cluster.Nodes;
import monalisa.tools.cluster.Leaves;

/**
 *
 * @author Jens Einloft
 */
public class TreeClustering implements Result {
    private static final long serialVersionUID = -8649514526288697494L;

    private ArrayList<Nodes> nodes = new ArrayList<Nodes>();
    private ArrayList<Edge> edges = new ArrayList<Edge>();
    private Vector<Leaves> groups = new Vector<Leaves>();

    public TreeClustering(ArrayList<Nodes> nodes, ArrayList<Edge> edges, Vector<Leaves> groups) {
        for(Nodes node : nodes)
            this.nodes.add(node);
        for(Edge edge : edges)
            this.edges.add(edge);
        for(Leaves leaves : groups)
            this.groups.add(leaves);
    }
    
    public String filenameExtension() {
        return "";
    }

    public void export(File path, Configuration config, Project project) throws IOException { }

   public ArrayList<Nodes> getNodes() {
        return nodes;
    }

    public ArrayList<Edge> getEdges() {
        return edges;
    }

    public Vector<Leaves> getGroups() {
        return groups;
    }

}
